package gus05.entity.gus.game.simulation.chain3;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Graphic;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;



public class SimulationChain3 implements Entity, Graphic, ActionListener {


    public String getName()				{return "gus.game.simulation.chain3";}
    public String getCreationDate()		{return "2007.12.15";}


    private Service persist;
    
    private ScreenJPanel screen;
    private JButton button;
    private JPanel panel;
    
    private JTextField field_number;
    private JTextField field_size;
    private JCheckBox check_noBorder;



    public SimulationChain3() throws Exception
    {
        persist = Outside.service(this,"gus.graphic.persistence.persistence1");
        
        screen = new ScreenJPanel();
        
        button = new JButton("start");
        button.addActionListener(this);
        
        check_noBorder = new JCheckBox("");
        
        field_number = new JTextField(6);
        field_number.setText("300");
        
        field_size = new JTextField(6);
        field_size.setText("16");
        
        persist.register(getName()+"_number",field_number);
        persist.register(getName()+"_size",field_size);
        persist.register(getName()+"_noborder",check_noBorder);
        
        JPanel p = new JPanel(new FlowLayout());
        
        p.add(new JLabel(" no border:"));
        p.add(check_noBorder);
        p.add(new JLabel(" number:"));
        p.add(field_number);
        p.add(new JLabel(" size:"));
        p.add(field_size);
        p.add(new JLabel(" situation:"));
        p.add(screen.infoPanel());
        
        panel = new JPanel(new BorderLayout());
        panel.add(p,BorderLayout.NORTH);
        panel.add(screen,BorderLayout.CENTER);
        panel.add(button,BorderLayout.SOUTH);
        
        new Thread(screen).start();
    }



    public JComponent gui()
    {return panel;}
    
    
    public void actionPerformed(ActionEvent e)
    {initSimulation();}
    
    
    
    private void initSimulation()
    {
        try
        {
            int number = Integer.parseInt(field_number.getText());
            int size = Integer.parseInt(field_size.getText());
            boolean infinite = check_noBorder.isSelected();
            
            screen.initSimulation(number,size,infinite);
        }
        catch(Exception e)
        {Outside.err(this,"initSimulation()",e);}
    }


}

