
package gus05.manager.gus.endorf.layer2;

import gus05.manager.gus.endorf.layer1.Source;
import gus05.manager.gus.endorf.layer1.organs.ResourceProvider;


public class Impl_ResourceProvider implements ResourceProvider {

    
    private String providerID;
    private String info;
    
    
    public Object provideResource(Source source, String key) throws Exception
    {
        if(key==null) throw new Exception("Invalid call for source: "+source+": null key");
        if(key.equals("")) throw new Exception("Invalid call for source: "+source+": empty key");
        
        if(key.equals("null")) return null;
        if(key.contains("-")) key = key.split("-",2)[0];
        
        analyzeKey(key);
        return provideResource(source);
    }
    
    
    private void analyzeKey(String key) throws Exception
    {
        providerID = null;
        info = null;
        
        if(key.contains("#"))
        {
            String[] n = key.split("#",2);
            providerID = n[0];
            info = n[1];
        }
        else if(EndorfSystem.isInternal(key))
        {providerID = EndorfSystem.RESOURCEPROVIDER_INTERNAL;info = key;}
        
        else if(EndorfSystem.isEntity(key))
        {providerID = EndorfSystem.RESOURCEPROVIDER_ENTITY;info = key;}
        
        else if(EndorfSystem.isProvider(key))
        {providerID = key;info = "";}
        
        else throw new Exception("Invalid key: "+key);
    }
    
    
    private Object provideResource(Source source) throws Exception
    {
        if(!EndorfSystem.isProvider(providerID))
            throw new Exception("Unknown resource provider: "+providerID);
        
        ResourceProvider provider = EndorfSystem.getProvider(providerID);
        return provider.provideResource(source,info);
    }
}
