package gus05.manager.gus.endorf.layer3.loading;

import gus05.manager.gus.endorf.layer3.system1.System1;
import gus05.manager.gus.endorf.layer3.tools.Tools_debug;

import java.io.File;
import java.util.Iterator;
import java.util.Map;
import java.util.Properties;


public class Loader_files extends Loader {

    
    
    public Loader_files()
    {super("files");}
    
    
    
    protected void outsideLoad() {}
    
    protected void insideLoad()
    {
        loadFromSystemProperties();
        loadFromSystemEnv();
        loadFromProperties();
    }
    
    
    
    private void loadFromSystemProperties()
    {
        Properties sysProp = System.getProperties();
        Iterator it = sysProp.keySet().iterator();
        
        int n = 0;
        while(it.hasNext())
        {
            String key = (String)it.next();
            String value = System.getProperty(key);
            boolean r = loadFromLine("sys."+key,value);
            if(r)n++;
        }
        debug("loadFromSystemProperties()","load "+n+" files from System properties");
    }
    
    
    
    
    private void loadFromSystemEnv()
    {
        Map envProp = System.getenv();
        Iterator it = envProp.keySet().iterator();
        
        int n = 0;
        while(it.hasNext())
        {
            String key = (String)it.next();
            String value = System.getenv(key);
            boolean r = loadFromLine("env."+key,value);
            if(r)n++;
        }
        debug("loadFromSystemEnv()","load "+n+" files from System env");
    }
    
    
    
    
    
    private void loadFromProperties()
    {
        Iterator it = System1.properties.keySet().iterator();
        
        int n = 0;
        while(it.hasNext())
        {
            String key = (String)it.next();
            if(key.startsWith("path.")) {checkFile(key);n++;}
        }
        debug("loadFromProperties()","load "+n+" files from properties");
    }
    
    
    
    
    
    
    
    
    
    
    
    private boolean loadFromLine(String key, String value)
    {
        String[] paths = value.split(File.pathSeparator);
        
        for(int i=0;i<paths.length;i++)
        {
            String path = paths[i];
            if(path.length()>0)
            {
                File f = new File(path);
                if(f.exists())
                {
                    if(paths.length==1) putFile("path."+key,f);
                    else putFile("path."+key+"."+i,f);
                    return true;
                }
            }
        }
        return false;
    }
    
    
    
    
    

    private void putFile(String key, File f)
    {
        System1.putFile(key,f);
        debug(key);
        increase();
    }

    
    
    private void checkFile(String key)
    {
        System1.fileManager.checkFile(key);
        debug(key);
        increase();
    }
    
    
    
    
    private void debug(String key)
    {
        if(System1.booleanProperty_false(System1.PROPKEY_DEBUGFILES))
            Tools_debug.displayFile(key,System1.file(key));
    }
}
