package gus05.manager.gus.endorf.layer3.loading;

import gus05.manager.gus.endorf.layer3.system1.System1;
import gus05.manager.gus.endorf.layer3.tools.Tools_file;
import gus05.manager.gus.endorf.layer3.tools.Tools_fileFilter;
import gus05.manager.gus.endorf.layer3.tools.Tools_publicKey;

import java.io.File;
import java.security.PublicKey;
import java.util.Iterator;
import java.util.Properties;
import java.util.Set;


public class Loader_pKeys extends Loader {

    
    public Loader_pKeys()
    {super("public keys");}
    
    
    protected void insideLoad()
    {
        try
        {
            Set set = insideDir("publickey");
            if(set==null) return;
            
            Iterator it = set.iterator();
            while(it.hasNext())
            {
                String name = (String)it.next();
                Properties p0 = insideProp("publickey/"+name);
                if(p0!=null) putPublicKey(name,p0);
            }
            debug("insideLoad()","load "+set.size()+" public keys from inside");
        }
        catch(Exception e)
        {System1.printError(this,"insideLoad()",e);}
    }
    
    
    
    
    
    protected void outsideLoad()
    {
        try
        {
            File publicKeyDir = outsideDir(System1.PATH_PUBLICKEYDIR);
            if(publicKeyDir==null) return;
            
            File[] f = publicKeyDir.listFiles(Tools_fileFilter.publickeyFileFilter);
            debug("outsideLoad()","load "+f.length+" public keys from: "+publicKeyDir.getAbsolutePath());
            for(int i=0;i<f.length;i++)loadFromFile(f[i]);
        }
        catch(Exception e)
        {System1.printError(this,"outsideLoad()",e);}
    }
    
    
    
    
    private void loadFromFile(File f)
    {
        try
        {
            Properties prop = Tools_file.prop(f);
            putPublicKey(f.getName(),prop);
        }
        catch(Exception e)
        {System1.printError(this,"loadFromFile(File)",e);}
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    private void putPublicKey(String name, Properties prop) throws Exception
    {
        String owner = prop.getProperty("owner");
        
        if(!name.endsWith(".publickey")) throw new Exception("wrong public key name: "+name);
        if(!name.equals(owner+".publickey")) throw new Exception("confusion for owner="+owner+" (resource name="+name+")");
        if(System1.pKeyMap.containsKey(owner)) throw new Exception("public key: "+owner+" is loaded many times");
        
        PublicKey publicKey = Tools_publicKey.buildPublicKey(prop);
        System1.pKeyMap.put(owner,publicKey);
        increase();
    }

}
