package gus05.manager.gus.endorf.layer3.loading;

import gus05.manager.gus.endorf.layer3.system1.System1;
import gus05.manager.gus.endorf.layer3.tools.Tools_fileFilter;

import java.applet.Applet;
import java.applet.AudioClip;
import java.io.File;
import java.net.URL;
import java.util.Iterator;
import java.util.Set;


public class Loader_sounds extends Loader {
    
    
    
    public Loader_sounds()
    {super("sounds");}
    
    
    
    protected void insideLoad()
    {
        try
        {
            Set set = insideDir("sound");
            if(set==null)return;
            
            Iterator it = set.iterator();
            while(it.hasNext())
            {
                String name = (String)it.next();
                URL url = insideURL("sound/"+name);
                putSound(name,url);
            }
            debug("insideLoad()","load "+set.size()+" sounds from inside");
        }
        catch(Exception e)
        {System1.printError(this,"insideLoad()",e);}
    }
    
    
    
    
    
    protected void outsideLoad()
    {
        try
        {           
            File soundDir = outsideDir(System1.PATH_SOUNDDIR);
            if(soundDir==null)return;
            
            File[] f = soundDir.listFiles(Tools_fileFilter.wavFileFilter);
            debug("outsideLoad()","load "+f.length+" sounds from: "+soundDir.getAbsolutePath());
            for(int i=0;i<f.length;i++) loadFromFile(f[i]);
            
            File[] d = soundDir.listFiles(Tools_fileFilter.dirFileFilter);
            for(int i=0;i<d.length;i++)
            {
                String base = d[i].getName();
                File[] f0 = d[i].listFiles(Tools_fileFilter.wavFileFilter);
                debug("outsideLoad()","load "+f0.length+" sounds from: "+d[i].getAbsolutePath());
                for(int j=0;j<f0.length;j++) loadFromFile(base,f0[j]);
            }
        }
        catch(Exception e)
        {System1.printError(this,"outsideLoad()",e);}
    }
    
    
    
    
    private void loadFromFile(File f)
    {
        try{putSound(f.getName(),f.toURL());}
        catch(Exception e)
        {System1.printError(this,"loadFromFile(File)",e);}
    }
    
    
    
    
    private void loadFromFile(String base, File f)
    {
        try{putSound(base+"@"+f.getName(),f.toURL());}
        catch(Exception e)
        {System1.printError(this,"loadFromFile(String,File)",e);}
    }
    
    
    
    
    
    
    
    private void putSound(String name, URL url)
    {
        if(!name.endsWith(".wav"))
        {debug("putSound(String,URL)","wrong wav name: "+name);return;}
        
        String key = name.substring(0,name.length()-4);
        if(System1.soundMap.containsKey(key))
            warning("putSound(String,URL)","soundID: "+key+" is loaded many times");
        
        AudioClip0 clip = new AudioClip0(url);
        System1.soundMap.put(key,clip);
        increase();
    }
    
    
    
    
    
    private boolean isSoundEnabled()
    {return System1.booleanProperty_true(System1.PROPKEY_APPSOUNDENABLED);}
    
    
    private class AudioClip0 implements AudioClip
    {
        private AudioClip clip;
        public AudioClip0(URL url)
        {clip = Applet.newAudioClip(url);}
        
        public void loop() {if(isSoundEnabled())clip.loop();}
        public void play() {if(isSoundEnabled())clip.play();}
        public void stop() {clip.stop();}
    }
}
