package gus05.manager.gus.endorf.layer3.system1;

import java.io.File;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class FileManager {

    
    public static final Pattern tag_pattern = Pattern.compile("<([^>]+)>");
    
    
    
    
    public boolean checkFile(String key)
    {
        try
        {
            if(!System1.hasProperty(key)) return false;
            String path = System1.getProperty(key);
            File file = resolveFile(path);
            System1.putFile(key,file);
            return true;
        }
        catch(Exception e)
        {e("checkFile(String)",e);}
        return false;
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    private File resolveFile(String path) throws Exception
    {
        int c = 0;
        while(path.startsWith("<"))
        {
            c++;
            Matcher m = tag_pattern.matcher(path);
            if(!m.find()) throw new Exception("wrong syntax for fileID: "+path);
            String tag = m.group(1);
            
            if(System1.hasFile(tag))
            {
                File f = System1.file(tag);
                path = path.replace(m.group(), f.getAbsolutePath());
            }
            else if(System1.hasProperty(tag))
            {
                String path0 = System1.getProperty(tag);
                path = path.replace(m.group(),path0);
            }
            else throw new Exception("fileID "+path+" can not be resolved");
            
            String s = File.separator;
            path = path.replace("\\",s).replace(s+s,s);
            
            if(c>100) System1.FATAL_ERROR(this,"resolveFile(String)","infinite loop detected\nstopping at path "+path);
        }
        return new File(path);
    }
    
    
    
    
    
    public void initFile(File file)
    {
        try
        {
            if(!System1.initOutside || file.exists()) return;
            file.getParentFile().mkdirs();
            file.createNewFile();
            d("initFile(File)","create file: "+file.getAbsolutePath());
        }
        catch(Exception e)
        {e("initFile(File)",e);}
    }
    
    
    
    
    
    public void initDir(File file)
    {
        try
        {
            if(!System1.initOutside || file.exists()) return;
            file.mkdirs();
            d("initFile(File)","create dir: "+file.getAbsolutePath());
        }
        catch(Exception e)
        {e("initDir(File)",e);}
    }
    
    
    
    
    
    private void d(String id, String message)
    {System1.printDebug(this,id,message);}
    
    private void e(String id, Exception e)
    {System1.printError(this,id,e);}
}
