package gus05.manager.gus.endorf.layer3.tools;

import gus05.manager.gus.endorf.layer3.system1.System1;



public class Tools_javaVersion {

    
    private static int[] currentVersion;
    
    
    private static void init()
    {
        String[] info = System.getProperty("java.version").split("[_\\.-]");

        currentVersion = new int[info.length];
        for(int i=0;i<info.length;i++)
        currentVersion[i] = convertToInt(info[i]);
    }
    
    
    
    
    private static int convertToInt(String value)
    {
        try{return Integer.parseInt(value);}
        catch(Exception e){return 0;}
    }
    
    
    
    
    
    public static boolean isJavaVersionSupported(String javaVersion)
    {
        try
        {
            if(currentVersion==null) init();
            int[] testedVersion = parseJavaVersion(javaVersion);
            // return true if currentVersion is higher than or equal to tested version
            return compare(currentVersion,testedVersion);
        }
        catch (Exception e)
        {
            System1.printError(Tools_javaVersion.class,"isJavaVersionSupported(String)",e);
            return false;
        }
    }
    
    
    
    
    
    
    private static int[] parseJavaVersion(String javaVersion) throws Exception
    {
        String[] info = javaVersion.split("[_\\.-]");
        if(info.length<3) throw new Exception("Invalid java version: "+javaVersion);
        
        int[] weigth = new int[info.length];
        for(int i=0;i<info.length;i++)
        weigth[i] = convertToInt(info[i]);
        return weigth;
    }
    
    
    
    
    private static boolean compare(int[] a, int[] b)
    {
        for(int i=0;i<Math.min(a.length,b.length);i++)
        {
            if(a[i]>b[i]) return true;
            if(a[i]<b[i]) return false;
        }
        return true;
    }
    
    


    
    
    
    
    
    // CODE SNIPET from Open Source Project jMule
    
//    private final static boolean isJavaVersionSupported() {
//        int major = 0, minor = 0, micro = 0;
//        StringTokenizer st = new StringTokenizer(System.getProperty("java.version"), ".");
//        try {
//            if (st.hasMoreTokens())
//                major = Integer.parseInt(st.nextToken());
//            if (st.hasMoreTokens())
//                minor = Integer.parseInt(st.nextToken());
//            if (st.hasMoreTokens()) {
//                String microString = st.nextToken();
//                if (microString.indexOf("_") > -1) {
//                    microString = microString.substring(0, microString.indexOf("_"));
//                } else if (microString.indexOf("-") > -1) {
//                    microString = microString.substring(0, microString.indexOf("-"));
//                }
//                micro = Integer.parseInt(microString);
//            }
//            return weigthVersion(major, minor, micro) >= weigthVersion(1, 4, 1);
//        } catch (Exception e) {
//            return false;
//        }
//    }
//    private final static int weigthVersion(int major, int minor, int micro) {
//        return major * 8 + minor * 4 + micro * 2;
//    }
}
