package gus05.manager.gus.endorf.layer4.internals1;

import java.io.File;
import java.io.PrintStream;

import gus05.framework.features.Provide;
import gus05.manager.gus.endorf.layer4.system2.System2;


public class AppLogFile implements Provide {

    
    public Object provide() throws Exception
    {
        File logFile = findLogFile();
        if(logFile==null) return null;

        PrintStream log = new PrintStream(logFile,"UTF-8");
        System2.printMessage(this,"provide()","log file initialized: "+logFile.getAbsolutePath());
        return log;
    }
    
    
    
    private File findLogFile() throws Exception
    {
        File logFile = System2.file(System2.PATH_LOGFILE);
        if(logFile!=null)
        {
            File parent = logFile.getParentFile();
            if(!parent.exists()) parent.mkdirs();
            return logFile;
        }
        
        File logDir = System2.file(System2.PATH_LOGDIR);
        if(logDir==null) return null;
        
        if(!logDir.exists()) logDir.mkdirs();
        if(!logDir.canWrite()) throw new Exception("log dir "+logDir.getAbsolutePath()+" has no writing right");
        
        String fileName = System2.appName+"_"+System2.now()+".log";
        return new File(logDir,fileName);
    }
    
    

}
