/*
 * Created on 20 juil. 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package gus05.manager.gus.endorf.layer4.providers.file;


import java.io.File;
import java.net.URL;

import gus05.manager.gus.endorf.layer1.Source;
import gus05.manager.gus.endorf.layer1.organs.ResourceProvider;
import gus05.manager.gus.endorf.layer3.tools.Tools_url;
import gus05.manager.gus.endorf.layer4.system2.System2;


public class ResourceProvider_file2a implements ResourceProvider {

    
    public Object provideResource(Source source, String key) throws Exception
    {
        if(key.contains(":"))
        {
            String[] n = key.split(":",2);
            key = n[0];
            String languages = n[1];
            return provideLingFile(key,languages);
        }
        else return provideFile(key);
    }
    
    
    
    
    
    private File provideFile(String key) throws Exception
    {
        File file = System2.findFile(key);
        URL url = findURL(key);
        Tools_url.copyFileFromURL(url,file);
        
        if(!file.exists()) throw new Exception("fileID "+key+" does not exist: "+file.getAbsolutePath());
        if(!file.isFile()) throw new Exception("fileID "+key+" is not a file: "+file.getAbsolutePath());
        return file;
    }
    
    
    
    
    private File provideLingFile(String key, String languages) throws Exception
    {
        File file = System2.findFile(key);
        String[] langs = languages.split("_");
        URL url = findURL(key);
        copyLingFilesFromURL(key,url,file,langs);
        
        if(!file.exists()) throw new Exception("fileID "+key+" does not exist: "+file.getAbsolutePath());
        if(!file.isFile()) throw new Exception("fileID "+key+" is not a file: "+file.getAbsolutePath());
        return file;
    }
    
    
    
    
    
    
    
    private void copyLingFilesFromURL(String key, URL url, File file, String[] langs) throws Exception
    {
        String name = file.getName();
        String[] n = name.split("\\.");
        String ext = n.length>1?n[n.length-1]:"";
        
        String root = n.length>1?name.substring(0,name.length()-ext.length()-1):name;
        if(root.charAt(root.length()-3)!='_')
            throw new Exception("wrong syntax for file name : "+name);
        root = root.substring(0,root.length()-3);
        
        String urlBase = url.toString();
        urlBase = urlBase.substring(0,urlBase.length()-4-ext.length());
        System2.printDebug(this,"copyLingFilesFromURL(String,URL,File,String[])","urlBase="+urlBase+" (with "+langs.length+" languages)");
        
        for(int i=0;i<langs.length;i++)
        {
            File lingFile = new File(file.getParent(),root+"_"+langs[i]+"."+ext);            
            URL lingURL = new URL(urlBase+"_"+langs[i]+"."+ext);
            System2.printDebug(this,"copyLingFilesFromURL(String,URL,File,String[])","copy from ling url="+lingURL);
            Tools_url.copyFileFromURL(lingURL,lingFile);
        }
    }
    
    
    
    
    
    
    private URL findURL(String key) throws Exception
    {
        if(key.startsWith("path.")) key = key.substring(5);
        if(!key.startsWith("url.")) key = "url."+key;
        return System2.url(key);
    }
}
