package gus05.manager.gus.endorf.layer4.system2;

import gus05.manager.gus.endorf.layer2.datasupport.SupportMap;
import gus05.manager.gus.endorf.layer3.loading.Loader;
import gus05.manager.gus.endorf.layer4.internals1.*;



public class Loader_internals extends Loader {

    
    
    public Loader_internals()
    {super("internals");}
    
    
    protected void outsideLoad(){}
    
    protected void insideLoad()
    {
        if(System2.hasFile(System2.PATH_ENTITYCALLFILE))
        {
            AppMappingRecorder mappingRecorder = new AppMappingRecorder();
            load(System2.INTERNAL_OBJ_MAPPINGRECORDER,mappingRecorder);
            load(System2.INTERNAL_MAP_MAPPINGRECORD,mappingRecorder.getMap());
        }
        
        if(System2.hasFile(System2.PATH_SECURITYDIR))
        {
            AppPrivateKeySigner signer = new AppPrivateKeySigner();
            load(System2.INTERNAL_OBJ_PRIVATEKEYSIGNER,signer);
            load(System2.INTERNAL_OBJ_PUBLICKEY,signer.getPublicKey());
        }
        
        load(System2.INTERNAL_STRING_MANAGERID,System2.managerID);
        load(System2.INTERNAL_FILE_ROOTDIR,System2.rootDir);
        
        load(System2.INTERNAL_EXECUTE_EXIT,new AppExecuteExit());
        load(System2.INTERNAL_OBJ_MAINGUI,new AppGuiBuilder());
        load(System2.INTERNAL_OBJ_CUSTOMIZEFRAME,new AppFrameCustomizer());
        
        load(System2.INTERNAL_OBJ_ENTITYRESOURCECALL,new AppEntityResourceCall());
        load(System2.INTERNAL_OBJ_FILEPROVIDER,new AppFileProvider());
        load(System2.INTERNAL_OBJ_ICONPROVIDER,new AppIconProvider());
        load(System2.INTERNAL_OBJ_SOUNDS,new AppSoundPlay());

        load(System2.INTERNAL_OBJ_ENTITYLOADER,new AppEntityLoader());
        load(System2.INTERNAL_OBJ_ENTITY,new AppEntityProvider());
        load(System2.INTERNAL_OBJ_NEWENTITY,new AppEntityProvider_New());
        load(System2.INTERNAL_OBJ_UNIQUEENTITY,new AppEntityProvider_Unique());
        load(System2.INTERNAL_OBJ_ENTITYSECUREDLIST,new AppEntitySecuredList());
        load(System2.INTERNAL_OBJ_ENTITYINFO,new AppEntityInfoProvider());
        
        load(System2.INTERNAL_OBJ_DATASTORE,System2.dataManager);
        load(System2.INTERNAL_MAP_DATASTORE_DATA,System2.dataManager.mapData);
        load(System2.INTERNAL_MAP_DATASTORE_FILES,System2.dataManager.mapFiles);
        load(System2.INTERNAL_MAP_DATASTORE_ACCESS,System2.dataManager.mapAccess);
        
        load(System2.INTERNAL_OBJ_ACTIONHANDLER,System2.actionManager);
        load(System2.INTERNAL_MAP_ACTIONS,System2.actionManager.getActionsMap());
        load(System2.INTERNAL_MAP_ACTIONINFOS,System2.actionManager.getActionInfosMap());
        
        AppServerManager serverManager = new AppServerManager();
        load(System2.INTERNAL_OBJ_SERVERS,serverManager);
        load(System2.INTERNAL_MAP_SERVERS,serverManager.getMap());
        
        load(System2.INTERNAL_MAP_OBJECTENTITY,System2.entityGenerator.getEntities());
        load(System2.INTERNAL_SUPPORT_LING, new AppLingSupport());
        load(System2.INTERNAL_OBJ_LINGSTRING,new AppLingString());
        
        load(System2.INTERNAL_STRING_USERNAME, System2.getProperty(System2.PROPKEY_APPUSER));
        load(System2.INTERNAL_STRING_MAINGUI_ENTIY,System2.mapping.get(System2.INTERNAL_OBJ_MAINGUI));
        
        load(System2.INTERNAL_MAP_DATEENTITY,System2.getDataMap0(System2.LOCATION_ENTITYDATEMAP));
        load(System2.INTERNAL_MAP_USEDDATEENTITY,System2.getDataMap0(System2.LOCATION_ENTITYUSEDDATEMAP));
        load(System2.INTERNAL_MAP_NUMBERENTITY,new SupportMap("EntityNumberMap"));
        load(System2.INTERNAL_SET_LINGSTRING_KEYS,System2.getDataSet0(System2.LOCATION_LINGKEYSSET));
        
        load(System2.INTERNAL_OBJ_CONFIRMEXIT,new AppConfirmExit());
        load(System2.INTERNAL_OBJ_ERRORNUMBER,new AppErrorNumber());
        load(System2.INTERNAL_MAP_STARTERRORS,System2.startManager.errors);
        load(System2.INTERNAL_OBJ_TIMER,new AppTimer());
        load(System2.INTERNAL_OBJ_LOGFILE,new AppLogFile());
    }
    
    
    
    
    
    private void load(String key, Object obj)
    {
        System2.putInternal(key,obj);
        if(System2.booleanProperty_false(System2.PROPKEY_DEBUGINTERNALS))
            debug("load(String,Object)","loading "+key);
        increase();
    }
    
    
}
